aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/ath79/nand
diff options
context:
space:
mode:
authorJeff Kletsky <git-commits@allycomm.com>2019-06-01 17:51:17 -0700
committerChuanhong Guo <gch981213@gmail.com>2019-11-14 14:38:58 +0800
commit55e6c903ae20bd8e694f4626166766e59602f87c (patch)
treeb2d18a8a34a8d8fd8c866b71e638444cf5f01b6b /target/linux/ath79/nand
parent20b3e77ba3e690453203587afa174bef43ee339b (diff)
downloadupstream-55e6c903ae20bd8e694f4626166766e59602f87c.tar.gz
upstream-55e6c903ae20bd8e694f4626166766e59602f87c.tar.bz2
upstream-55e6c903ae20bd8e694f4626166766e59602f87c.zip
ath79: GL-AR300M: provide NAND support; increase to 4 MB kernel
The GL.iNet GL-AR300M has been supported by the ar71xx and ath79 platforms with access to its 16 MB NOR flash, but not its 128 MB SPI NAND flash. This commit provides support for the NAND through the upstream SPI-NAND framework. Devices with both NOR and NAND flash can support independent firmware on each, with U-Boot able to boot from either. The OEM U-Boot will fall back to the NOR firmware after three "unsuccessful" boots. The family of GL-AR300M devices on the ath79 platform now includes: * glinet,gl-ar300m-lite "generic" target, NOR-only board * glinet,gl-ar300m-nand "nand" target * glinet,gl-ar300m-nor "nand" target (NAND-aware) NB: This commit increases the kernel size from 2 MB to 4 MB "Force-less" sysupgrade is presently supported from the current versions of following NOR-based firmwre images to the version of glinet,gl-ar300m-nor firmware produced by this commit: * gl-ar300m -- OEM v3 NOR ar71xx (openwrt-ar300m16-*.bin) * gl-ar300m -- OpenWrt 18.06 ar71xx * gl-ar300m -- OpenWrt 19.07 ar71xx Other upgrades to these images should be performed through U-Boot. The GL-AR300M OEM U-Boot allows upload and flashing of either NOR firmware (sysupgrade.bin) or NAND firmware (factory.img) through its HTTP-based GUI. Serial connectivity is not required. The glinet,gl-ar300m-nand and glinet,gl-ar300m-nor images generated after this commit should safely flash each other using sysupgrade. The boot counter is implemented by the OEM using u-boot-env. At this time, it does not appear that the switch on the side of the unit can be used to select NOR vs. NAND boot and the fail-over is only from NAND to NOR. To save flash wear, it is only reset when running the glinet,gl-ar300m-nand firmware. NAND-specific base-files are used to remove impact on existing generic and tiny targets. As there is now no "generic" build appropriate for the GL-AR300M16, (or for users of the GL-AR300M that do not need access to NAND) it will be introduced in a subsequent commit. Note: `mtd_get_mac_binary art 0x6` does not return the proper MAC and the GL.iNet source indicates that only the 0x0 offset is valid The ar71xx targets are unmodified. Signed-off-by: Jeff Kletsky <git-commits@allycomm.com>
Diffstat (limited to 'target/linux/ath79/nand')
-rwxr-xr-xtarget/linux/ath79/nand/base-files/etc/board.d/01_leds3
-rwxr-xr-xtarget/linux/ath79/nand/base-files/etc/init.d/bootcount13
-rw-r--r--target/linux/ath79/nand/base-files/lib/upgrade/glinet.sh90
-rw-r--r--target/linux/ath79/nand/base-files/lib/upgrade/platform.sh12
4 files changed, 112 insertions, 6 deletions
diff --git a/target/linux/ath79/nand/base-files/etc/board.d/01_leds b/target/linux/ath79/nand/base-files/etc/board.d/01_leds
index f851b3d886..f58527d87e 100755
--- a/target/linux/ath79/nand/base-files/etc/board.d/01_leds
+++ b/target/linux/ath79/nand/base-files/etc/board.d/01_leds
@@ -8,7 +8,8 @@ board=$(board_name)
boardname="${board##*,}"
case "$board" in
-glinet,gl-ar300m-nand)
+glinet,gl-ar300m-nand|\
+glinet,gl-ar300m-nor)
ucidef_set_led_netdev "lan" "LAN" "gl-ar300m:green:lan" "eth0"
;;
netgear,wndr4300)
diff --git a/target/linux/ath79/nand/base-files/etc/init.d/bootcount b/target/linux/ath79/nand/base-files/etc/init.d/bootcount
new file mode 100755
index 0000000000..c82386b55f
--- /dev/null
+++ b/target/linux/ath79/nand/base-files/etc/init.d/bootcount
@@ -0,0 +1,13 @@
+#!/bin/sh /etc/rc.common
+
+# SPDX-License-Identifier: GPL-2.0
+
+START=99
+
+boot() {
+ case $(board_name) in
+ glinet,gl-ar300m-nand)
+ fw_setenv bootcount 0
+ ;;
+ esac
+}
diff --git a/target/linux/ath79/nand/base-files/lib/upgrade/glinet.sh b/target/linux/ath79/nand/base-files/lib/upgrade/glinet.sh
new file mode 100644
index 0000000000..86729f8f2a
--- /dev/null
+++ b/target/linux/ath79/nand/base-files/lib/upgrade/glinet.sh
@@ -0,0 +1,90 @@
+# SPDX-License-Identifier: GPL-2.0
+#
+# Copyright (C) 2019 Jeff Kletsky
+#
+
+glinet_using_boot_dev_switch() {
+ if [ "$(fw_printenv -n boot_dev 2>/dev/null)" = "on" ] ; then
+ >&2 echo "NOTE: boot_dev=on; use switch to control boot partition"
+ true
+ else
+ false
+ fi
+}
+
+glinet_set_next_boot_nand() {
+ mkdir -p /var/lock
+ ! glinet_using_boot_dev_switch && \
+ fw_setenv bootcount 0 && \
+ >&2 echo "Next boot set for NAND"
+}
+
+glinet_set_next_boot_nor() {
+ mkdir -p /var/lock
+ ! glinet_using_boot_dev_switch && \
+ fw_setenv bootcount 3 && \
+ >&2 echo "Next boot set for NOR"
+}
+
+glinet_nand_nor_do_upgrade() {
+ set_next_boot_nand() { glinet_set_next_boot_nand; }
+ set_next_boot_nor() { glinet_set_next_boot_nor; }
+ nand_nor_do_upgrade "$1"
+}
+
+nand_nor_do_upgrade() {
+ local upgrade_file="$1"
+
+ local pn
+ local found=""
+ local err
+
+ case "$(get_magic_long "$upgrade_file")" in
+
+ "27051956") # U-Boot Image Magic
+
+ for pn in "nor_${PART_NAME}" "$PART_NAME" ; do # firmware
+ if [ "$(find_mtd_index "$pn")" ] ; then
+ PART_NAME="$pn"
+ found="yes"
+ break
+ fi
+ done
+ if [ "$found" = "yes" ] ; then
+ >&2 echo "Running NOR upgrade"
+ default_do_upgrade "$upgrade_file"
+ # At this time, default_do_upgrade() exits on error
+ type set_next_boot_nor >/dev/null && set_next_boot_nor
+ else
+ >&2 echo "ERROR: UPGRADE FAILED: Unable to locate '$PART_NAME' or 'nor_${PART_NAME}'"
+ exit 1
+ fi
+ ;;
+
+ *) # otherwise a file that nand_do_upgrade can process
+
+ for pn in "nand_${CI_KERNPART}" "$CI_KERNPART" ; do # kernel
+ if [ "$(find_mtd_index "$pn")" ] ; then
+ CI_KERNPART="$pn"
+ break
+ fi
+ done
+ for pn in "nand_${CI_UBIPART}" "$CI_UBIPART" ; do # ubi
+ if [ "$(find_mtd_index "$pn")" ] ; then
+ CI_UBIPART="$pn"
+ break
+ fi
+ done
+ for pn in "nand_${CI_ROOTPART}" "$CI_ROOTPART" ; do #rootfs
+ if [ "$(find_mtd_index "$pn")" ] ; then
+ CI_ROOTPART="$pn"
+ break
+ fi
+ done
+ >&2 echo "Running NAND upgrade"
+ # TODO: change order when NAND upgrade offers return
+ type set_next_boot_nand >/dev/null && set_next_boot_nand
+ nand_do_upgrade "$upgrade_file"
+ ;;
+ esac
+}
diff --git a/target/linux/ath79/nand/base-files/lib/upgrade/platform.sh b/target/linux/ath79/nand/base-files/lib/upgrade/platform.sh
index 3956d5d73f..69105b1668 100644
--- a/target/linux/ath79/nand/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ath79/nand/base-files/lib/upgrade/platform.sh
@@ -1,20 +1,22 @@
-#
# Copyright (C) 2011 OpenWrt.org
-#
PART_NAME=firmware
-REQUIRE_IMAGE_METADATA=1
+REQUIRE_IMAGE_METADATA=1
platform_check_image() {
return 0
}
+RAMFS_COPY_BIN='fw_printenv fw_setenv'
+RAMFS_COPY_DATA='/etc/fw_env.config /var/lock/fw_printenv.lock'
+
platform_do_upgrade() {
local board=$(board_name)
case "$board" in
- glinet,gl-ar300m-nand)
- default_do_upgrade "$1"
+ glinet,gl-ar300m-nand|\
+ glinet,gl-ar300m-nor)
+ glinet_nand_nor_do_upgrade "$1"
;;
*)
nand_do_upgrade "$1"